import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { render } from 'react-dom';
import { HashRouter as Router, Route } from 'react-router-dom';
import PageProxy from './page-proxy';

var BootstrapLite =
/*#__PURE__*/
function () {
  function BootstrapLite() {}

  var _proto = BootstrapLite.prototype;

  _proto.getMountTarget = function getMountTarget(node) {
    if (node === void 0) {
      node = 'bsMain';
    }

    if (this.mountTarget instanceof HTMLElement) return this.mountTarget;
    if (node instanceof HTMLElement) return node;

    if (typeof node === 'string') {
      return document.querySelector(node);
    }

    throw new Error('挂载点即不是dom对象，也不是querySelector可选择的字符串，请检测项目配置');
  }
  /**
   * @param {string | HTMLElement} options.el - 应用的挂载点 可选
   * @param {ReactComponent} options.layout - 布局组件 可选
   * @param {ReactComponent} options.loadingComp - 加载中显示的组件 可选
   * @param {ReactComponent} options.errorComp - 出错后显示的组件 可选
   * @param {string} options.homePage - 用做首页的地址，默认为home
   */
  ;

  _proto.config = function config(options) {
    this.mountTarget = this.getMountTarget(options.el);
    this.loadingComp = options.loadingComp;
    this.errorComp = options.errorComp;
    this.layout = options.layout;
    this.homePage = options.homePage;
  };

  _proto.start = function start() {
    var _this = this;

    render(React.createElement(Router, null, React.createElement(Route, {
      path: "*",
      render: function render(props) {
        return React.createElement(PageProxy, _extends({
          LoadingComp: _this.loadingComp,
          ErrorComp: _this.errorComp,
          Layout: _this.layout,
          homePage: _this.homePage
        }, props));
      }
    })), this.mountTarget);
  };

  return BootstrapLite;
}();

var appLite = new BootstrapLite();
export { appLite };

if (module.hot) {
  module.hot.accept('./page-proxy', function () {
    appLite.start();
  });
}